// FILENAME:	ODM_City_on_the_Edge.cs
//
// AUTHORS:  	Orogogus: h2liu@iname.com
//------------------------------------------------------------------------------

$missionName = "ODM_City_On_The_Edge";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
//exec("ScanComponents.cs");
exec("AIPilots.cs");

$redCounter = 0;
$blueCounter = 0;
$redScore = 0;
$blueScore = 0;
$redKills = 0;
$blueKills = 0;
$redDeaths = 0;
$blueDeaths = 0;

$cowardice = 2000;


//=================


function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function setDefaultMissionItems() 
{
	exec("defaultVehicles");
	allowComponent("all", true);
	allowWeapon("all", true);
	allowComponent(875,FALSE);//FieldStabilizer
	allowWeapon(3,FALSE);//Disrupter
}


function onMissionStart()
{
	marsSounds();
}


function onMissionLoad()
{
  cdAudioCycle("Purge", "Terror", "Watching"); 
  %nowDate = getDate();
  %nowTime = getTime();
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ "server start";
  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

  $startTime = getCurrentTime();

  $maxBlues = 24;
  $maxReds = 24;

  initDrops();

  for(%i=0; %i<$maxBlues; %i++)
  {
     $blueTeam[%i] = 0;
     $bluePilot[%i] = 0;
  }

  for(%i=0; %i<$maxReds; %i++)
  {
     $redTeam[%i] = 0;
     $redPilot[%i] = 0;
  }

  spawnBlue();
  spawnRed();

  schedule("endMission();", 1200); 
}

// Water Tower splash functionality
function structure::onDestroyed(%this, %attackerId){
	// Which water tower was destroyed?
	if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower1")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash1"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash1"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower2")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash2"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash2"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower3")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash3"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash3"), 0, true);
	}
}


//===================


function adjustTeam(%player, %vehicle)
{
  %initLetter = strAlign(1, l, %vehicle.vehicleName);
  if(%initLetter < "H") adjustTeam1(%player, %vehicle);
  else if((%initLetter >= "H") && (%initLetter < "L")) adjustTeam2(%player, %vehicle);
  else if((%initLetter >= "L") && (%initLetter < "Q")) adjustTeam3(%player, %vehicle);
  else if(%initLetter >= "Q") adjustTeam4(%player, %vehicle);
  else
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }
}



function adjustTeam1(%player, %vehicle)
{
  if(%vehicle.vehicleName == "Adjudicator")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Apocalypse")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Avenger")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Basilisk")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Bolo")
  {
     %vehicle.type = "tank";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Disrupter")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Dreadlock")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Emancipator")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Executioner")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Goad")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Gorgon")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }
}


function adjustTeam2(%player, %vehicle)
{
  if(%vehicle.vehicleName == "Harabec's Predator")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Basilisk")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Apocalypse")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Disruptor")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Gorgon")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Minotaur")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Myrmidon")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Paladin")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Knight's Talon")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }
}


function adjustTeam3(%player, %vehicle)
{
  if(%vehicle.vehicleName == "Metagen Goad")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Metagen Seeker")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Metagen Shepherd")
  {
     %vehicle.type = "herc";
	     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Minotaur")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Myrmidon")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Olympian")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Paladin")
  {
     %vehicle.type = "tank";
     %vehicle.side= "human";
  }

  else if(%vehicle.vehicleName == "Platinum Guard Adjudicator")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Platinum Guard Executioner")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }
}

function adjustTeam4(%player, %vehicle)
{
  if(%vehicle.vehicleName == "Recluse")
  {
     %vehicle.type = "tank";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Seeker")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }
				
  else if(%vehicle.vehicleName == "Shepherd")
  {
     %vehicle.type = "herc";
     %vehicle.side= "cybrid";
  }

  else if(%vehicle.vehicleName == "Talon")
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }

  else
  {
     %vehicle.type = "herc";
     %vehicle.side= "human";
  }
}


//============


function vehicle::OnAdd(%vehicle)
{
  %player = playerManager::vehicleIdToPlayerNum(%vehicle);
  %vehicle.location = 1;

  %player.vehicleId = %vehicle;
  %vehicle.vehicleName = getVehicleName(%vehicle);
  %vehicle.color = getTeam(%vehicle);
  if(%player != 0) %vehicle.name = %player.name;
  adjustTeam(%player, %vehicle);

  if ((%vehicle.side == "human") && (%vehicle.color == "Blue Team"))
  {
     setTeam(%vehicle, *IDSTR_TEAM_RED);
     say(%player, 0, "All humans are on the red team");
     redrop(%vehicle);
  }

  if ((%vehicle.side== "cybrid") && (%vehicle.color == "Red Team"))
  {
     setTeam(%vehicle, *IDSTR_TEAM_BLUE);
     say(%player, 0, "All Cybrids are on the blue team");
     redrop(%vehicle);
  }

  addTeamArray(%vehicle);
  %vehicle.state = "human";

  %now = getCurrentTime();

//  %totalTime = ($server::TimeLimit * 60);
//
//   Normally you would use the above line, but this map overrides the time limit to
//   try to avoid some odd AI spawning behavior upon mission end.

  %totalTime = (20 * 60);
  %timeLeft = (%totalTime - (%now - $startTime));
  if(%player != 0) setHudTimer(%timeLeft, -1, "Time Left", 1, %player);
}


function vehicle::OnDestroyed( %victim, %destroyer )
{
  removeTeamArray(%victim);

	%victimNum = playerManager::vehicleIdToPlayerNum( %victim );
	%destroyerNum = playerManager::vehicleIdToPlayerNum( %destroyer );


	if(getTeam(%victim) == *IDSTR_TEAM_BLUE)
  {
    $blueDeaths++;
    $blueScore = $blueScore - $deathPoints;
  }
	else if(getTeam(%victim) == *IDSTR_TEAM_PURPLE)
  {
    $purpleDeaths++;
    $purpleScore = $purpleScore - $deathPoints;
  }
	else if(getTeam(%victim) == *IDSTR_TEAM_RED)
  {
    $redDeaths++;
    $redScore = $redScore - $deathPoints;
  }
	else if(getTeam(%victim) == *IDSTR_TEAM_YELLOW)
  {
    $yellowDeaths++;
    $yellowScore = $yellowScore - $deathPoints;
  }


	if(getTeam(%destroyer) == *IDSTR_TEAM_BLUE)
  {
    $blueKills++;
    $blueScore = $blueScore + $killPoints;
  }
	else if(getTeam(%destroyer) == *IDSTR_TEAM_PURPLE)
  {
    $purpleKills++;
    $purpleScore = $purpleScore + $killPoints;
  }
	else if(getTeam(%destroyer) == *IDSTR_TEAM_RED)
  {
    $redKills++;
    $redScore = $redScore + $killPoints;
  }
	else if(getTeam(%destroyer) == *IDSTR_TEAM_YELLOW)
  {
    $yellowKills++;
    $yellowScore = $yellowScore + $killPoints;
  }


  %victimNum.location = 0;

  if(%victim.state != "coward")
  {
  	%message = getFancyDeathMessage(getHUDName(%victim), getHUDName(%destroyer));
  	if(%message != "") say( 0, 0, %message);
  }
  else
  {
    %announce = getHUDName(%victim);
    say("everybody", 0,  %announce @ " is executed for cowardice");
  }

  if(%victimNum == 0)
  {
    if(getTeam(%victim) == *IDSTR_TEAM_BLUE)
    {
      $blueCounter--;
      if($blueCounter < 5)
      {
        schedule("spawnBlue();", 15);
      }
    }

    else if(getTeam(%victim) == *IDSTR_TEAM_RED)
    {
      $redCounter--;
      if($redCounter < 5)
      {
        schedule("spawnRed();", 15);
      }
    }

    schedule( "deleteObject(" @ %victim @ ");", 10 );
  }
}


function player::OnAdd(%player)
{
  %player.name = getName(%player);
  %player.location = 0;
  %player.startTime = getCurrentTime();

  %nowDate = getDate();
  %nowTime = getTime();
  %player.IP = getConnection(%player);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " joined the game (" @ %player.IP @ ")";

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

}


function player::OnRemove(%player)
{
  %player.name = getName(%player);
  %nowDate = getDate();
  %nowTime = getTime();
  %timeEnd = getCurrentTime();
  %timeIn = timeDifference( %timeEnd, %player.startTime);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " left the game (" @ %player.IP @ ") -- " @ %timeIn;

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);
}


// ========================== AI spawning functions


function spawnBlue()
{
  %pilot = pickAPilot("cybrid");

  %targType = RandomInt(20,31);
  if ( %targType>28)
   %targType = RandomInt(35,37);

  // get appropriate type Tank or Herc
  %type = Herc;
  if ( %targType == 25  || %targType == 26 )   %type = Tank;

  //------  Specializations

  if(%pilot == 227)
  {
    %targType = 29;
    %type = Herc;
  }

  //================

	%herc = NewObject("Drone", %type, %targType ); 
  %herc.pilot = %pilot;
	setPilotId(%herc,%pilot);
  setTeam(%herc, *IDSTR_TEAM_BLUE);
  addTeamArray(%herc);

  %i = randomInt(8282, 8291);
	warp(%herc, %i);
  %herc.spawn = %i;

  addToSet( "MissionCleanup", %herc );
  $blueCounter++;
  say("everybody", 0, "More glitches!");

  %herc.state = "idle";
  copAnAttitude(%herc);

  if($blueCounter < 5)
  {
		schedule("spawnBlue();", 15);
	}
}


function spawnRed()
{
  %pilot = pickAPilot("human");

  %targType = RandomInt(1,19);

  if ( %targType>7 && %targType<15 )
   %targType = RandomInt(10,16);
  else if ( %targType>=15 && %targType<19 )
   %targType = RandomInt(30,33);
  else if ( %targType==19 )
   %targType = 41;

  // get appropriate type Tank or Herc
  %type = Herc;
  if ( %targType>5  && %targType<= 8 )   %type = Tank;
  if ( %targType>14 && %targType<= 17 )  %type = Tank;
  if ( %targType>24 && %targType<= 26 )  %type = Tank;
  if ( %targType>30 && %targType<= 32 )  %type = Tank;
  if ( %targType == 41 )  %type = Tank;

  //------  Specializations

  if(%pilot == 81)
  {
    %temp = randomInt(0,1);
    if(%temp == 0)
    {
      %targType = 40;
      %type = Herc;
    }
    if(%temp == 1)
    {
      %targType = 45;
      %type = Tank;
    }
  }

  if(%pilot == 82)
  {
    %targType = 42;
    %type = Herc;
  }

  //==========

	%herc = NewObject("Drone2", %type, %targType); 
  %herc.pilot = %pilot;
	setPilotId(%herc, %pilot);
  setTeam(%herc, *IDSTR_TEAM_RED);
  addTeamArray(%herc);

  %herc.state = "idle";
  copAnAttitude(%herc);

  %i = randomInt(8293, 8302);
  warp(%herc, %i);
  %herc.spawn = %i;

  addToSet( "MissionCleanup", %herc );
  $redCounter++;
  say("everybody", 0, "Send in the meat.");

  if($redCounter < 5)
  {
		schedule("spawnRed();", 15);
	}
}


function clearAIs()
{
  for(%i=0; %i<$maxBlues; %i++)
  {
     if (($blueTeam[%i] != 0) && ($blueTeam[%i].state != "human"))
     {
      deleteObject($blueTeam[%i]);
      $blueTeam[%i] = 0;
      $bluePilot[%i] = 0;
     }
  }
  $blueCounter = 0;
  spawnBlue();

  for(%i=0; %i<$maxReds; %i++)
  {
     if (($redTeam[%i] != 0) && ($redTeam[%i].state != "human"))
     {
       deleteObject($redTeam[%i]);
       $redTeam[%i] = 0;
       $redPilot[%i] = 0;
     }
  }
  $redCounter = 0;
  spawnRed();
}


function pickAPilot(%side)
{
  if(%side == "human")
  {
    while(%a == 0)
    {
      %a = 1;
      %i = randomInt(41, 82);
      for(%b = 0; %b < $maxReds; %b++)
      {
        if($redPilot[%b] == %i)
          {
            %a = 0;
          }
      }
    }
    return %i;
  }

  if(%side == "cybrid")
  {
    while(%a == 0)
    {
      %a = 1;
      %i = randomInt(181, 227);
      for(%b = 0; %b < $maxBlues; %b++)
      {
        if($bluePilot[%b] == %i)
        {
          %a = 0;
        }
      }
    }
    return %i;
  }
}


//===============  AI pilot functions




function findNearestFriend(%herc)
{
  %color = getTeam(%herc);

  if(%color == *IDSTR_TEAM_BLUE)
  {

    %chosenOne = 0;
    %nearest = 9999;

    for(%i=0; %i<$maxBlues; %i++)
    {
      if($blueTeam[%i] != 0)
      {
        %nearby = getDistance(%herc, $blueTeam[%i]);
        if((%nearby < %nearest) && ($blueTeam[%i].state != "idle"))
        {
          %nearest = %nearby;
          $blueTeam[%i] = %chosenOne;
        }
      }
    }
    return %chosenOne;
  }


  if(%color == *IDSTR_TEAM_RED)
  {

    %chosenOne = 0;
    %nearest = 9999;

    for(%i=0; %i<$maxReds; %i++)
    {
      if($redTeam[%i] != 0)
      {
        %nearby = getDistance(%herc, $redTeam[%i]);
        if((%nearby < %nearest) && ($redTeam[%i].state != "idle"))
        {
          %nearest = %nearby;
          $redTeam[%i] = %chosenOne;
        }
      }
    }
    return %chosenOne;
  }
}

function findNearestFoe(%herc)
{
  %color = getTeam(%herc);

  if(%color == *IDSTR_TEAM_BLUE)
  {

    %chosenOne = 0;
    %nearest = 9999;

    for(%i=0; %i<$maxReds; %i++)
    {
      if($redTeam[%i] != 0)
      {
        %nearby = getDistance(%herc, $redTeam[%i]);
        if(%nearby < %nearest)
        {
          %nearest = %nearby;
          %chosenOne = $redTeam[%i];
        }
      }
    }
    return %chosenOne;
  }


  if(%color == *IDSTR_TEAM_RED)
  {

    %chosenOne = 0;
    %nearest = 9999;

    for(%i=0; %i<$maxBlues; %i++)
    {
      if($blueTeam[%i] != 0)
      {
        %nearby = getDistance(%herc, $blueTeam[%i]);
        if(%nearby < %nearest)
        {
          %nearest = %nearby;
          %chosenOne = $blueTeam[%i];
        }
      }
    }
    return %chosenOne;
  }
}



function copAnAttitude(%herc)
{
  %newVictim = findNearestFoe(%herc);
  if(getDistance(%herc, %newVictim) < $cowardice) order(%herc, attack, %newVictim);
  else 
  {
     %herc.state = "coward";
     healObject(%herc, -50000);
  }
}



//==================  Team array functions


function addTeamArray(%vehicle)
{
  %color = getTeam(%vehicle);

  if(%color == *IDSTR_TEAM_BLUE)
  {
    for(%i=0; %i<$maxBlues; %i++)
    {
      if($blueTeam[%i] == 0)
      {
       $blueTeam[%i] = %vehicle;
       %i = $maxBlues;
      }
    }
  }

  if(%color == *IDSTR_TEAM_RED)
  {
    for(%i=0; %i<$maxReds; %i++)
    {
      if($redTeam[%i] == 0)
      {
       $redTeam[%i] = %vehicle;
       %i = $maxReds;
      }
    }
  }
}

function removeTeamArray(%vehicle)
{
  %color = getTeam(%vehicle);

  if(%color == *IDSTR_TEAM_BLUE)
  {
    for(%i=0; %i<$maxBlues; %i++)
    {
      if($blueTeam[%i] == %vehicle)
      {
       $blueTeam[%i] = 0;
       $bluePilot[%i] = 0;
       %i = $maxBlues;
      }
    }
  }

  if(%color == *IDSTR_TEAM_RED)
  {
    for(%i=0; %i<$maxReds; %i++)
    {
      if($redTeam[%i] == %vehicle)
      {
       $redTeam[%i] = 0;
       $redPilot[%i] = 0;
       %i = $maxReds;
      }
    }
  }
}


//======================= setRules

function setRules()
{
  %rules = "<F2>GAME TYPE: \n<F0>Cybrids vs. Humans Deathmatch\n\n" @        
  "<tIDMULT_TDM_MAPNAME>"    @ 
  $missionName               @
  "\n\n<F2>CHANGES:\n"       @
  "<F0>Humans on the red team, Cybrids on the blue.\n\n" @
  "<F0>Up to five AIs spawn in on both teams.\n\n" @
  "<F0>AIs have random personalities, from the campaign squadmate AIs.\n\n" @
  "<F0>When spawned, AIs will automatically find the nearest target to attack.\n\n" @
  "<F0>Execution for cowardice means that an AI unit is running off into the hills, and has roamed too far away from the nearest enemy target.\n\n" @
  "\n\n<F2>RULES/OBJECTIVES:\n" @
  "<F0>Locate and destroy enemy vehicles.\n\n" @
  "<tIDMULT_TDM_SCORING_1>"  @
  "<tIDMULT_TDM_SCORING_2>"  @
  $killPoints                @
  "<tIDMULT_TDM_SCORING_3>"  @
  "<tIDMULT_TDM_SCORING_4>"  @
  $deathPoints               @
  "<tIDMULT_TDM_SCORING_5>"  @
  "<tIDMULT_TDM_SCORING_6>"  @
  "<tIDMULT_STD_ITEMS>" ;

   setGameInfo(%rules);      
}


// setup the rules
// this has to be called after the definition of setRules
setRules();


//======================


function endMission()
{
  for(%i=0; %i<$maxBlues; %i++)
  {
     if (($blueTeam[%i] != 0) && ($blueTeam[%i].state != "human"))
     deleteObject($blueTeam[%i]);
     $blueTeam[%i] = 0;
  }
  $blueCounter = 5;

  for(%i=0; %i<$maxReds; %i++)
  {
     if (($redTeam[%i] != 0) && ($redTeam[%i].state != "human"))
     deleteObject($redTeam[%i]);
     $redTeam[%i] = 0;
  }
  $redCounter = 5;

  missionEndConditionMet();
}

//=====================

function timeDifference(%t1, %t2)
{
   // calculates the time difference t1-t2 and returns it as a string
   // such as "1 minute, 32 seconds"
   
   %diff = %t1 - %t2;
   
   %hours = 0;
   %minutes = 0;
   
   // can't do rounding in console so hack it
   %temp = %diff;
   %temp = %temp - 3600;

   while(%temp >= 0)
   {
      %hours = %hours + 1;
      %temp = %temp - 3600;
   }

   %temp = %temp + 3600;

   %output = "";
   if(%hours > 0)
   {
      %output = %output @ %hours @ " ";
      if(%hours == 1)
      {
         %output = %output @ "hour";      
      }
      else
      {
         %output = %output @ "hours";
      }
      
      if(%temp > 0)
      {
         // make space for further output
         %output = %output @ ", ";
      }
   }


   %temp = %temp - 60;
   
   while(%temp >= 0)
   {
      %minutes = %minutes + 1;
      %temp = %temp - 60;
   }
      
   %temp = %temp + 60;
   
   if(%minutes > 0)
   {
      %output = %output @ %minutes @ " ";
      if(%minutes == 1)
      {
         %output = %output @ "minute";      
      }
      else
      {
         %output = %output @ "minutes";
      }
      
      if(%temp > 0)
      {
         // make space for seconds output
         %output = %output @ ", ";
      }
   }

   
   %seconds = %temp;

   if(%seconds > 0)
   {
      %output = %output @ %seconds @ " ";
      if(%seconds == 1)
      {
         %output = %output @ "second";
      }
      else
      {
         %output = %output @ "seconds";
      }
   }
   
   return %output;
}

//====================

function initDrops()
{
  $maxBlueDPs = 0;
  $maxRedDPs++;

  for(%i=8000; %i<9000; %i++)
  {
    if(getObjectName(getGroup(%i)) == "dropPointGroup2")
    {
      $maxBlueDPs++;
      $blueDropPoint[$maxBlueDPs] = %i;  
    }

    if(getObjectName(getGroup(%i)) == "dropPointGroup3")
    {
      $maxRedDPs++;
      $redDropPoint[$maxBlueDPs] = %i;  
    }
  }
}

//=====================



function getTeamScore(%team)
{
	%team = getTeamNameFromTeamId(%team);
	if(%team == *IDSTR_TEAM_PURPLE) 
	{
		return($purpleScore);
	}
	if(%team == *IDSTR_TEAM_YELLOW) 
	{
		return($yellowScore);
	}
	if(%team == *IDSTR_TEAM_RED) 
	{
		return($redScore);
	}
	if(%team == *IDSTR_TEAM_BLUE) 
	{
		return($blueScore);
	}

	return 0;
} 


function getTeamKills(%team)
{
	%team = getTeamNameFromTeamId(%team);
	if(%team == *IDSTR_TEAM_PURPLE) 
	{
		return($purpleKills);
	}
	if(%team == *IDSTR_TEAM_YELLOW) 
	{
		return($yellowKills);
	}
	if(%team == *IDSTR_TEAM_RED) 
	{
		return($redKills);
	}
	if(%team == *IDSTR_TEAM_BLUE) 
	{
		return($blueKills);
	}

	return 0;
} 


function getTeamDeaths(%team)
{
	%team = getTeamNameFromTeamId(%team);
	if(%team == *IDSTR_TEAM_PURPLE) 
	{
		return($purpleDeaths);
	}
	if(%team == *IDSTR_TEAM_YELLOW) 
	{
		return($yellowDeaths);
	}
	if(%team == *IDSTR_TEAM_RED) 
	{
		return($redDeaths);
	}
	if(%team == *IDSTR_TEAM_BLUE) 
	{
		return($blueDeaths);
	}

	return 0;
} 



function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
	   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SQUAD;
	   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_SCORE;
	   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getTeam";
	   $ScoreBoard::PlayerColumnFunction2 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction4 = "getKills";
	   $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
   }
   else
   {
      // Player ScoreBoard column headings
      $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
      $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SCORE;
      $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_KILLS;
      $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_DEATHS;

      // Player ScoreBoard column functions
      $ScoreBoard::PlayerColumnFunction1 = "getSquad";
      $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
      $ScoreBoard::PlayerColumnFunction3 = "getKills";
      $ScoreBoard::PlayerColumnFunction4 = "getDeaths";
   }

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
   $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
   $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
   $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
   $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}



//====================

function vehicle::OnMessage(%this, %message, %a, %b, %c, %d, %e, %f, %g, %h, %i)
{ 
  if(%this.state == "human") return;
  if(%message == "TargetDestroyed")
  {
     %newTarg = findNearestFoe(%this);
     %targName = getHudName(%newTarg);
     order(%this, attack, %newTarg);
  }
}


//====================

function cycleNavPoint( %playerId, %navToCycle, %nextNavPoint )
{
  say(0, 0, %playerId @ ": Test message");
}
